/* _help.c
 *
 * By W.H.Scholten 2001
 * This file is released to the public domain.
 */

void use() {
	fprintf(stderr, "Use: bbctape [{-e | -b} [-f]] [-t] [-D] <audio file> ..\n"
			"     bbctape -w <audio file> [-freq <sample freq>] [-baud <baud rate> ] [-bits <start/stop bits>] [-B] [-T] <file1> ...\n"
			"or\n"
			"     bbctape -h\n"
			"for more information.\n\n"
		);
	exit(1);
}

void show_help()
{
	printf("\nbbctape, version "VERSION", (C) 2001 W.H.Scholten, 1996 R.Schmidt, 1996 O.Stauning\n\n"
		   "bbctape can:\n"
		   "  - show BBC computer files in an audio file (or line-in)\n"
		   "  - decode audio files made from BBC microcomputer tapes, or directly from the sound card by playing such a tape to 'line in', and can write the data to files, data blocks or a tape image (by default only file information on blocks recognized is shown).\n"
		   "  - create audio files suitable for writing to tape or create the ouput on the sound card's line-out (you could connect line-out directly to a BBC microcomputer...).\n"
		   "Synopsis:\n"
		   "     bbctape [{-e | -b} [-f]] [-t] [-D] <file> ..\n"
		   "     bbctape -w <audio file> [-freq <sample freq>] [-baud <baud rate> ] [-bits <start/stop bits>] [-B] [-T] <bbc file> ...\n"
		   "     bbctape -h\n"
		   "Parameters:\n"
		   " -e : extract files in archive format (i.e. with associated .inf files)\n"
		   " -b : extract files as blocks (including the tape header and data crc)\n"
		   " -f : for block/file extracting: force handling of bad blocks (display block information, write block)\n"
		   " -t : extract a tape image (i.e. a bitstream)\n"

		   " -w <file> : create a raw audio file (or write to line-out)\n"
		   " -B : the next argument is a basename for tape blocks to be written (instead of archive format)\n"
		   " -T : the next argument is a tape image (instead of archive format)\n"

		   " -freq : set sample frequency (for file/dsp)\n"
		   " -baud, -bits : set baud rate, start/stop bits (only used in the saving code, but DON'T use unless you know what you're doing)\n"
		   " -D : enable verbose debugging and error messages\n"
		   "      (might be useful in case you get CRC errors)\n"
		   " <file> : audio file or sound card device (/dev/dsp); input files must be unsigned 8-bit mono 22-44 kHz raw audio\n"

		   " -?,-h : show this help text\n"
		   "If none of the options -e, -b, -t or -w are specified, BBC files found in the tape file <file> are shown.\n\n"
		);
}

void show_version() {
	printf("bbctape "VERSION"\n");
}
