/*
 * Copyright (C) W.H.Scholten 2001.
 *
 * Copyright (C) Ole Stauning 1996.
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the copyright holder
 * not be used in advertising or publicity pertaining to distribution
 * of the software without specific, written prior permission. The
 * copyright holder makes no representations about the suitability of
 * this software for any purpose. It is provided "as is" without express
 * or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

int  start_bits = BBCTAPE_DEFAULT_START_BITS;
int  number_of_start_bits = BBCTAPE_DEFAULT_NUMBER_OF_START_BITS;
int  stop_bits = BBCTAPE_DEFAULT_STOP_BITS;
int  number_of_stop_bits = BBCTAPE_DEFAULT_NUMBER_OF_STOP_BITS;

void tape_set_bits(char *optarg) {
	int  j;

	number_of_stop_bits = 0;
	number_of_start_bits = 0;
	stop_bits = start_bits = 0;

	for (j=0;optarg[j]!='/';j++) {
		if (optarg[j] == '1')
			start_bits |= 1<<j;
		else if (optarg[j] != '0') use();
	}

	if ((number_of_start_bits = j) == 0) {
		fprintf(stderr,"you must have startbits\n");
		exit(1);
	}

	for (j++;optarg[j]!='\0';j++) {
		if (optarg[j] == '1')
			stop_bits |= 1 << (j-number_of_start_bits-1);
		else if (optarg[j] != '0') use();
	}

	if ((number_of_stop_bits = j-number_of_start_bits-1) == 0) {
		fprintf(stderr,"you must have stopbits\n");
		exit(1);
	}

	if (start_bits & 1) {
		fprintf(stderr,"first startbit has to be 0\n");
		exit(1);
	}
}
