/* uef_extract v3
 *
 * main.cpp, by W.H.Scholten 2001
 *
 * This file is released to the public domain.
 *
 * uef_extract extracts files from uef format into the archive format or raw
 * tape blocks.
 *
 * Uses uef.cpp/uef.h by Thomas Harte.
 */

#include <stdio.h>
#include <string.h>

#include "uef.h"


//#define DEBUG
#ifdef DEBUG
#  define DEB(x) x
#else
#  define DEB(x)
#endif

void bbcim_replace_bad_chars(char *unix_bbcfile_naam);
int  bbcim_printable_bbcfilename(char *name);
int  bbcim_rename_sequential(char *name);
long bbcim_fcrc(char *bestand, int verbose);
long bbcim_data_crc(void *data, int length);


#define True   1
#define False  0

C_UEF input;

#include "_bbcim_code.c"

#include "_help.c"

int tape_extract = 0;
int tape_extract_blocks = 0;
int tape_extract_image = 0;
int tape_catalogue = 1;

char *tape_image_name;

#include "_io.c"
#include "_write_tape_image.c"
#include "_uef_extract.c"


int main(int argc, char **argv) {
	if (argc == 1)
		help();

	for (int i=1; i<argc; i++) {
		if (strlen(argv[i]) == 0) continue;
		switch (argv[i][0]) {
		case '-':
			if (strlen(argv[i]) != 2) use();
			switch (argv[i][1]) {
			case 'e':
				tape_extract = 1;
				break;
			case 'b':
				tape_extract_blocks = 1;
				break;
			case 't':
				tape_extract_image = 1;
				break;
//			case 'f':
//				write_bad_blocks = true;
				break;
			case '?':
			case 'h':
				help();
				break;
			default:
				use();
				break;
			}
			break;

		default:
			if (tape_extract_image) {
				if (i+1 >= argc) use(); /* 2 filenames required */
				tape_image_name = argv[i+1];
				FILE *fp = fopen(tape_image_name, "wb");
				if (fp == NULL) {
					perror(tape_image_name);
					exit(1);
				}
				tapeimage_write_header(fp);
				fclose(fp);
				uef_extract(argv[i]);
				i++;
			} else {
				uef_extract(argv[i]);
			}
		}
	}
}
